/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIIPCBuffer.idl
 */

#ifndef __gen_nsIIPCBuffer_h__
#define __gen_nsIIPCBuffer_h__


#ifndef __gen_nsIPipeListener_h__
#include "nsIPipeListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIRunnable; /* forward declaration */

class nsIRequestObserver; /* forward declaration */

#define NS_IPCBUFFER_CLASSNAME "IPC Buffer"
#define NS_IPCBUFFER_CONTRACTID "@mozilla.org/process/ipc-buffer;1"
     
#define NS_IPCBUFFER_CID                         \
{ /* 8431e1c1-7ab1-11d4-8f02-006008948af5 */     \
   0x8431e1c1, 0x7ab1, 0x11d4,                   \
{0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5} }

/* starting interface:    nsIIPCBuffer */
#define NS_IIPCBUFFER_IID_STR "8431e1c0-7ab1-11d4-8f02-006008948af5"

#define NS_IIPCBUFFER_IID \
  {0x8431e1c0, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIIPCBuffer : public nsIPipeListener {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IIPCBUFFER_IID)

  /**
   * Opens byte buffer
   *
   */
  /* void open (in unsigned long maxBytes, in boolean overflowFile); */
  NS_SCRIPTABLE NS_IMETHOD Open(PRUint32 maxBytes, PRBool overflowFile) = 0;

  /**
   * Loads an URI into the console buffer (use instead of the open method)
   * @param aURI        URI to be loaded
   *
   * @param maxBytes    maximum number of bytes to be read
   *                    (maxBytes == -1 => unlimited buffer size)
   *
   * @param synchronous determines whether to load synchronously
   */
  /* void openURI (in nsIURI aURI, in long maxBytes, in boolean synchronous, in nsIRequestObserver observer, in nsISupports ctxt); */
  NS_SCRIPTABLE NS_IMETHOD OpenURI(nsIURI *aURI, PRInt32 maxBytes, PRBool synchronous, nsIRequestObserver *observer, nsISupports *ctxt) = 0;

  /**
   * Opens an input stream to access buffer data;
   * should be called only after the OnStopRequest call to streamListener.
   * Note: On closing the stream, the buffer will be cleared
   */
  /* nsIInputStream openInputStream (); */
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(nsIInputStream **_retval NS_OUTPARAM) = 0;

  /**
   * Returns data from buffer
   * (as a NUL-terminated string)
   */
  /* string getData (); */
  NS_SCRIPTABLE NS_IMETHOD GetData(char **_retval NS_OUTPARAM) = 0;

  /**
   * True if onStopRequest method of StreamListener has been invoked
   */
  /* readonly attribute boolean stopped; */
  NS_SCRIPTABLE NS_IMETHOD GetStopped(PRBool *aStopped) = 0;

  /**
   * Count of total bytes in buffer (or overflow file)
   */
  /* readonly attribute unsigned long totalBytes; */
  NS_SCRIPTABLE NS_IMETHOD GetTotalBytes(PRUint32 *aTotalBytes) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIIPCBuffer, NS_IIPCBUFFER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIIPCBUFFER \
  NS_SCRIPTABLE NS_IMETHOD Open(PRUint32 maxBytes, PRBool overflowFile); \
  NS_SCRIPTABLE NS_IMETHOD OpenURI(nsIURI *aURI, PRInt32 maxBytes, PRBool synchronous, nsIRequestObserver *observer, nsISupports *ctxt); \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(nsIInputStream **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetData(char **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetStopped(PRBool *aStopped); \
  NS_SCRIPTABLE NS_IMETHOD GetTotalBytes(PRUint32 *aTotalBytes); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIIPCBUFFER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Open(PRUint32 maxBytes, PRBool overflowFile) { return _to Open(maxBytes, overflowFile); } \
  NS_SCRIPTABLE NS_IMETHOD OpenURI(nsIURI *aURI, PRInt32 maxBytes, PRBool synchronous, nsIRequestObserver *observer, nsISupports *ctxt) { return _to OpenURI(aURI, maxBytes, synchronous, observer, ctxt); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(nsIInputStream **_retval NS_OUTPARAM) { return _to OpenInputStream(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetData(char **_retval NS_OUTPARAM) { return _to GetData(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetStopped(PRBool *aStopped) { return _to GetStopped(aStopped); } \
  NS_SCRIPTABLE NS_IMETHOD GetTotalBytes(PRUint32 *aTotalBytes) { return _to GetTotalBytes(aTotalBytes); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIIPCBUFFER(_to) \
  NS_SCRIPTABLE NS_IMETHOD Open(PRUint32 maxBytes, PRBool overflowFile) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(maxBytes, overflowFile); } \
  NS_SCRIPTABLE NS_IMETHOD OpenURI(nsIURI *aURI, PRInt32 maxBytes, PRBool synchronous, nsIRequestObserver *observer, nsISupports *ctxt) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenURI(aURI, maxBytes, synchronous, observer, ctxt); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(nsIInputStream **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenInputStream(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetData(char **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetData(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetStopped(PRBool *aStopped) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetStopped(aStopped); } \
  NS_SCRIPTABLE NS_IMETHOD GetTotalBytes(PRUint32 *aTotalBytes) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetTotalBytes(aTotalBytes); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsIPCBuffer : public nsIIPCBuffer
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIIPCBUFFER

  nsIPCBuffer();

private:
  ~nsIPCBuffer();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsIPCBuffer, nsIIPCBuffer)

nsIPCBuffer::nsIPCBuffer()
{
  /* member initializers and constructor code */
}

nsIPCBuffer::~nsIPCBuffer()
{
  /* destructor code */
}

/* void open (in unsigned long maxBytes, in boolean overflowFile); */
NS_IMETHODIMP nsIPCBuffer::Open(PRUint32 maxBytes, PRBool overflowFile)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void openURI (in nsIURI aURI, in long maxBytes, in boolean synchronous, in nsIRequestObserver observer, in nsISupports ctxt); */
NS_IMETHODIMP nsIPCBuffer::OpenURI(nsIURI *aURI, PRInt32 maxBytes, PRBool synchronous, nsIRequestObserver *observer, nsISupports *ctxt)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInputStream openInputStream (); */
NS_IMETHODIMP nsIPCBuffer::OpenInputStream(nsIInputStream **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string getData (); */
NS_IMETHODIMP nsIPCBuffer::GetData(char **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute boolean stopped; */
NS_IMETHODIMP nsIPCBuffer::GetStopped(PRBool *aStopped)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute unsigned long totalBytes; */
NS_IMETHODIMP nsIPCBuffer::GetTotalBytes(PRUint32 *aTotalBytes)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIIPCBuffer_h__ */
