/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM nsIPipeTransport.idl
 */

#ifndef __gen_nsIPipeTransport_h__
#define __gen_nsIPipeTransport_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

#ifndef __gen_nsIPipe_h__
#include "nsIPipe.h"
#endif

#ifndef __gen_nsIFile_h__
#include "nsIFile.h"
#endif

#ifndef __gen_nsIRequest_h__
#include "nsIRequest.h"
#endif

#ifndef __gen_nsIPipeListener_h__
#include "nsIPipeListener.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIRequest; /* forward declaration */

class nsIFile; /* forward declaration */

class nsIInputStream; /* forward declaration */

class nsIOutputStream; /* forward declaration */

class nsIStreamListener; /* forward declaration */

class nsIPipeTransportHeaders; /* forward declaration */

class nsIPipeTransportListener; /* forward declaration */

#include "IPCProcess.h"
#define NS_PIPETRANSPORT_CLASSNAME "Pipe Transport"
#define NS_PIPETRANSPORT_CONTRACTID "@mozilla.org/process/pipe-transport;1"
#define NS_PIPETRANSPORT_CID                     \
{ /* 8431e101-7ab1-11d4-8f02-006008948af5 */     \
   0x8431e101, 0x7ab1, 0x11d4,                   \
{0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5} }

/* starting interface:    nsIPipeTransport */
#define NS_IPIPETRANSPORT_IID_STR "8431e100-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORT_IID \
  {0x8431e100, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

/**
 * The nsIPipeTransport interface executes a file in a new process and
 * communicates with the process using pipes.
 *
 * OWNERSHIP AND THREADING MODEL for nsPipeTransport:
 *
 * nsPipeTransport can be created in any thread with an event queue.
 *
 * nsPipeTransport lives only in the thread that it was created in.
 *
 * nsPipeTransport creates a helper thread object, nsStdoutPoller and retains
 * an owning reference to it. nsStdoutPoller also holds a strong reference
 * to a proxy interface (nsIPipeTransportListener) implemented by
 * nsPipeTransport, which is released when the polling thread terminates.
 *
 * The polling thread terminates when it is "interrupted" by nsPipeTransport or
 * when EOF/error is encountered in reading data from the process STDOUT.
 *
 * The "terminate" method should *always* be called to release the process
 * resources when done.
 *
 * For asynchronous reading, when nsStdoutPoller terminates of its own accord,
 * any stream listener is informed by invoking OnStopRequest.
 * Usually this listener will be the same as the owner of nsPipeTransport.
 * (If the owner initiates the request shutdown by first calling "cancel",
 *  then the OnStopRequest method is *not* invoked, because it is assumed
 *  that the listener/owner is already aware of the shutdown.)
 *
 */
class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransport : public nsIRequest {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORT_IID)

  /**
     * Old, oboslete version of init, kept for compatibility reasons
     * For parameters please refer to init above and open
     */
  /* void init (in nsIFile executable, [array, size_is (argCount)] in string args, in unsigned long argCount, [array, size_is (envCount)] in string env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean noProxy, in boolean mergeStderr, in nsIPipeListener console); */
  NS_SCRIPTABLE NS_IMETHOD Init(nsIFile *executable, const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) = 0;

  /**
     * Initializes PipeTransport by executing the specified file using the
     * supplied argument list and environment variables.
     * It is expected that nsIPipeTransport will be embedded in a
     * full-featured channel, which will also act as an async stream
     * observer/listener and forward calls to the actual observer/listener.
     *
     * @param executable   executable file
     * @param cwd          working directory for the excutable
     * @param startupFlags flags defining how the process should be created
     */
  /* void initialize (in nsIFile executable, in nsIFile cwd, in unsigned long startupFlags); */
  NS_SCRIPTABLE NS_IMETHOD Initialize(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) = 0;

  /**
     * Opens a PipeTransport by executing the specified file using the
     * supplied argument list and environment variables.
     * It is expected that nsIPipeTransport will be embedded in a
     * full-featured channel, which will also act as an async stream
     * observer/listener and forward calls to the actual observer/listener.
     *
     * @param args        arguments string array
     *                    (excluding the executable path itself)
     * @param env         environment (variable=value) string array
     * @param timeoutMS   timeout (in milliseconds) after which the process
     *                    at the other end of the pipe can be assumed to be
     *                    dead
     *                    (if == 0, a default value, usually an hour, is used)
     * @param killString  string to be transmitted to process before it is
     *                    killed (specify null string, if none)
     * @param noProxy     do not use proxy for async callback
     *                    (must use join to terminate process, in this case)
     * @param mergeStderr merge STDERR with STDOUT
     * @param console     nsIPipeListener object to capture STDERR
     */
  /* void open ([array, size_is (argCount)] in string args, in unsigned long argCount, [array, size_is (envCount)] in string env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean noProxy, in boolean mergeStderr, in nsIPipeListener console); */
  NS_SCRIPTABLE NS_IMETHOD Open(const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) = 0;

  /**
     * detach process after start
     */
  enum { PROCESS_DETACHED = 1 };

  enum { INHERIT_PROC_ATTRIBS = 2 };

  /**
     * Returns console object used to capture STDERR by default
     */
  /* readonly attribute nsIPipeListener console; */
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeListener * *aConsole) = 0;

  /**
     * Returns listener object to feed data to STDIN
     * (call to OnStopRequest closes STDIN)
     */
  /* readonly attribute nsIStreamListener listener; */
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener * *aListener) = 0;

  /**
     * Specifies interface to handle MIME headers read from STDOUT
     */
  /* attribute nsIPipeTransportHeaders headerProcessor; */
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders * *aHeaderProcessor) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders * aHeaderProcessor) = 0;

  /**
     * Controls console logging of STDOUT from process
     */
  /* attribute boolean loggingEnabled; */
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) = 0;

  /**
     * Open an input stream on this transport.
     *
     * @param offset - read starting at this offset
     * @param count  - read this many bytes (pass PRUint32(-1) if unlimited)
     * @param flags  - optional transport specific flags
     */
  /* nsIInputStream openInputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) = 0;

  /**
     * Open an output stream on this transport.
     *
     * @param offset - write starting at this offset
     * @param count  - write no more than this many bytes (pass PRUint32(-1) if unlimited)
     * @param flags  - optional transport specific flags
     */
  /* nsIOutputStream openOutputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) = 0;

  /**
     * Asynchronously read data from the transport.
     *
     * @param listener - notify this listener when data is available
     * @param ctxt     - opaque parameter passed to listener methods
     * @param offset   - read starting at this offset
     * @param count    - read this many bytes (pass PRUint32(-1) if unlimited)
     * @param flags    - optional transport specific flags
     */
  /* nsIRequest asyncRead (in nsIStreamListener listener, in nsISupports ctxt, in unsigned long offset, in unsigned long count, in unsigned long flags); */
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) = 0;

  /**
     * Checks if process is still actively piping I/O
     */
  /* boolean isAttached (); */
  NS_SCRIPTABLE NS_IMETHOD IsAttached(PRBool *_retval NS_OUTPARAM) = 0;

  /**
     * Joins STDOUT handling thread (blocking until STDOUT is closed),
     * (Necessary and only works if noProxy is true)
     * The process still needs to be terminated to free resources.
     */
  /* void join (); */
  NS_SCRIPTABLE NS_IMETHOD Join(void) = 0;

  /**
     * Terminates process, if active.
     */
  /* void terminate (); */
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) = 0;

  /**
     * Returns exit code of process which has exited;
     *  fails with an exception if process is still attached.
     */
  /* long exitCode (); */
  NS_SCRIPTABLE NS_IMETHOD ExitCode(PRInt32 *_retval NS_OUTPARAM) = 0;

  /**
     * Writes string to process STDIN (synchronously)
     * (Note: child process may exit for valid reasons even before
     *  the first call to writeSync, causing an an exception to be
     *  thrown because STDIN has been closed by the child.)
     */
  /* void writeSync (in string inputData, in unsigned long inputLength); */
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) = 0;

  /**
     * closes process STDIN (required even if no data is being transmitted)
     */
  /* void closeStdin (); */
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) = 0;

  /**
     * Writes stream data to process STDIN (asynchronously),
     * and close inputStream and STDIN after writing, if requested
     */
  /* void writeAsync (in nsIInputStream aFromStream, in unsigned long aCount, in boolean closeAfterWrite); */
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) = 0;

  /**
     * Transmits command string to process, blocks for output and returns the
     * STDOUT response as a string up to maxChars (=-1 for unlimited) long,
     * delimited by an optional prompt.
     * If prompt begins with newline, that newline character is returned,
     * but the rest of the prompt string is not returned.
     * If clear is true, any prior data in STDOUT is cleared.
     */
  /* string execPrompt (in string command, in string prompt, in long maxOutputLen, in boolean clearPrev); */
  NS_SCRIPTABLE NS_IMETHOD ExecPrompt(const char *command, const char *prompt, PRInt32 maxOutputLen, PRBool clearPrev, char **_retval NS_OUTPARAM) = 0;

  /**
     * Blocks for output and returns the first line from STDOUT
     * as a string, up to maxChars (=-1 for unlimited) long.
     * NOTE: This method is intended for short output; for longer
     * output, reading using a stream is the better method.
     */
  /* string readLine (in long maxOutputLen); */
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) = 0;

  /* attribute unsigned long bufferSegmentSize; */
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) = 0;

  /* attribute unsigned long bufferMaxSize; */
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) = 0;

  /* attribute unsigned long headersMaxSize; */
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) = 0;
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransport, NS_IPIPETRANSPORT_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORT \
  NS_SCRIPTABLE NS_IMETHOD Init(nsIFile *executable, const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console); \
  NS_SCRIPTABLE NS_IMETHOD Initialize(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags); \
  NS_SCRIPTABLE NS_IMETHOD Open(const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console); \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeListener * *aConsole); \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener * *aListener); \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders * *aHeaderProcessor); \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders * aHeaderProcessor); \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled); \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled); \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD IsAttached(PRBool *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD Join(void); \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void); \
  NS_SCRIPTABLE NS_IMETHOD ExitCode(PRInt32 *_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength); \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void); \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite); \
  NS_SCRIPTABLE NS_IMETHOD ExecPrompt(const char *command, const char *prompt, PRInt32 maxOutputLen, PRBool clearPrev, char **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM); \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize); \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize); \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize); \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORT(_to) \
  NS_SCRIPTABLE NS_IMETHOD Init(nsIFile *executable, const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) { return _to Init(executable, args, argCount, env, envCount, timeoutMS, killString, noProxy, mergeStderr, console); } \
  NS_SCRIPTABLE NS_IMETHOD Initialize(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) { return _to Initialize(executable, cwd, startupFlags); } \
  NS_SCRIPTABLE NS_IMETHOD Open(const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) { return _to Open(args, argCount, env, envCount, timeoutMS, killString, noProxy, mergeStderr, console); } \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeListener * *aConsole) { return _to GetConsole(aConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener * *aListener) { return _to GetListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders * *aHeaderProcessor) { return _to GetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders * aHeaderProcessor) { return _to SetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return _to GetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return _to SetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) { return _to OpenInputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) { return _to OpenOutputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) { return _to AsyncRead(listener, ctxt, offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD IsAttached(PRBool *_retval NS_OUTPARAM) { return _to IsAttached(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return _to Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) { return _to Terminate(); } \
  NS_SCRIPTABLE NS_IMETHOD ExitCode(PRInt32 *_retval NS_OUTPARAM) { return _to ExitCode(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) { return _to WriteSync(inputData, inputLength); } \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) { return _to CloseStdin(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) { return _to WriteAsync(aFromStream, aCount, closeAfterWrite); } \
  NS_SCRIPTABLE NS_IMETHOD ExecPrompt(const char *command, const char *prompt, PRInt32 maxOutputLen, PRBool clearPrev, char **_retval NS_OUTPARAM) { return _to ExecPrompt(command, prompt, maxOutputLen, clearPrev, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) { return _to ReadLine(maxOutputLen, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) { return _to GetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) { return _to SetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) { return _to GetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) { return _to SetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) { return _to GetHeadersMaxSize(aHeadersMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) { return _to SetHeadersMaxSize(aHeadersMaxSize); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORT(_to) \
  NS_SCRIPTABLE NS_IMETHOD Init(nsIFile *executable, const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) { return !_to ? NS_ERROR_NULL_POINTER : _to->Init(executable, args, argCount, env, envCount, timeoutMS, killString, noProxy, mergeStderr, console); } \
  NS_SCRIPTABLE NS_IMETHOD Initialize(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags) { return !_to ? NS_ERROR_NULL_POINTER : _to->Initialize(executable, cwd, startupFlags); } \
  NS_SCRIPTABLE NS_IMETHOD Open(const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console) { return !_to ? NS_ERROR_NULL_POINTER : _to->Open(args, argCount, env, envCount, timeoutMS, killString, noProxy, mergeStderr, console); } \
  NS_SCRIPTABLE NS_IMETHOD GetConsole(nsIPipeListener * *aConsole) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetConsole(aConsole); } \
  NS_SCRIPTABLE NS_IMETHOD GetListener(nsIStreamListener * *aListener) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetListener(aListener); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeaderProcessor(nsIPipeTransportHeaders * *aHeaderProcessor) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeaderProcessor(nsIPipeTransportHeaders * aHeaderProcessor) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHeaderProcessor(aHeaderProcessor); } \
  NS_SCRIPTABLE NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoggingEnabled(aLoggingEnabled); } \
  NS_SCRIPTABLE NS_IMETHOD OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenInputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->OpenOutputStream(offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncRead(listener, ctxt, offset, count, flags, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD IsAttached(PRBool *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsAttached(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD Join(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Join(); } \
  NS_SCRIPTABLE NS_IMETHOD Terminate(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Terminate(); } \
  NS_SCRIPTABLE NS_IMETHOD ExitCode(PRInt32 *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExitCode(_retval); } \
  NS_SCRIPTABLE NS_IMETHOD WriteSync(const char *inputData, PRUint32 inputLength) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteSync(inputData, inputLength); } \
  NS_SCRIPTABLE NS_IMETHOD CloseStdin(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->CloseStdin(); } \
  NS_SCRIPTABLE NS_IMETHOD WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteAsync(aFromStream, aCount, closeAfterWrite); } \
  NS_SCRIPTABLE NS_IMETHOD ExecPrompt(const char *command, const char *prompt, PRInt32 maxOutputLen, PRBool clearPrev, char **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ExecPrompt(command, prompt, maxOutputLen, clearPrev, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ReadLine(maxOutputLen, _retval); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferSegmentSize(PRUint32 *aBufferSegmentSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferSegmentSize(PRUint32 aBufferSegmentSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBufferSegmentSize(aBufferSegmentSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetBufferMaxSize(PRUint32 *aBufferMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetBufferMaxSize(PRUint32 aBufferMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetBufferMaxSize(aBufferMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD GetHeadersMaxSize(PRUint32 *aHeadersMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetHeadersMaxSize(aHeadersMaxSize); } \
  NS_SCRIPTABLE NS_IMETHOD SetHeadersMaxSize(PRUint32 aHeadersMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHeadersMaxSize(aHeadersMaxSize); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransport : public nsIPipeTransport
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORT

  nsPipeTransport();

private:
  ~nsPipeTransport();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransport, nsIPipeTransport)

nsPipeTransport::nsPipeTransport()
{
  /* member initializers and constructor code */
}

nsPipeTransport::~nsPipeTransport()
{
  /* destructor code */
}

/* void init (in nsIFile executable, [array, size_is (argCount)] in string args, in unsigned long argCount, [array, size_is (envCount)] in string env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean noProxy, in boolean mergeStderr, in nsIPipeListener console); */
NS_IMETHODIMP nsPipeTransport::Init(nsIFile *executable, const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void initialize (in nsIFile executable, in nsIFile cwd, in unsigned long startupFlags); */
NS_IMETHODIMP nsPipeTransport::Initialize(nsIFile *executable, nsIFile *cwd, PRUint32 startupFlags)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void open ([array, size_is (argCount)] in string args, in unsigned long argCount, [array, size_is (envCount)] in string env, in unsigned long envCount, in unsigned long timeoutMS, in string killString, in boolean noProxy, in boolean mergeStderr, in nsIPipeListener console); */
NS_IMETHODIMP nsPipeTransport::Open(const char **args, PRUint32 argCount, const char **env, PRUint32 envCount, PRUint32 timeoutMS, const char *killString, PRBool noProxy, PRBool mergeStderr, nsIPipeListener *console)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIPipeListener console; */
NS_IMETHODIMP nsPipeTransport::GetConsole(nsIPipeListener * *aConsole)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* readonly attribute nsIStreamListener listener; */
NS_IMETHODIMP nsPipeTransport::GetListener(nsIStreamListener * *aListener)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute nsIPipeTransportHeaders headerProcessor; */
NS_IMETHODIMP nsPipeTransport::GetHeaderProcessor(nsIPipeTransportHeaders * *aHeaderProcessor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetHeaderProcessor(nsIPipeTransportHeaders * aHeaderProcessor)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean loggingEnabled; */
NS_IMETHODIMP nsPipeTransport::GetLoggingEnabled(PRBool *aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetLoggingEnabled(PRBool aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIInputStream openInputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::OpenInputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIInputStream **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIOutputStream openOutputStream (in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::OpenOutputStream(PRUint32 offset, PRUint32 count, PRUint32 flags, nsIOutputStream **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIRequest asyncRead (in nsIStreamListener listener, in nsISupports ctxt, in unsigned long offset, in unsigned long count, in unsigned long flags); */
NS_IMETHODIMP nsPipeTransport::AsyncRead(nsIStreamListener *listener, nsISupports *ctxt, PRUint32 offset, PRUint32 count, PRUint32 flags, nsIRequest **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isAttached (); */
NS_IMETHODIMP nsPipeTransport::IsAttached(PRBool *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void join (); */
NS_IMETHODIMP nsPipeTransport::Join()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void terminate (); */
NS_IMETHODIMP nsPipeTransport::Terminate()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* long exitCode (); */
NS_IMETHODIMP nsPipeTransport::ExitCode(PRInt32 *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void writeSync (in string inputData, in unsigned long inputLength); */
NS_IMETHODIMP nsPipeTransport::WriteSync(const char *inputData, PRUint32 inputLength)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void closeStdin (); */
NS_IMETHODIMP nsPipeTransport::CloseStdin()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void writeAsync (in nsIInputStream aFromStream, in unsigned long aCount, in boolean closeAfterWrite); */
NS_IMETHODIMP nsPipeTransport::WriteAsync(nsIInputStream *aFromStream, PRUint32 aCount, PRBool closeAfterWrite)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string execPrompt (in string command, in string prompt, in long maxOutputLen, in boolean clearPrev); */
NS_IMETHODIMP nsPipeTransport::ExecPrompt(const char *command, const char *prompt, PRInt32 maxOutputLen, PRBool clearPrev, char **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* string readLine (in long maxOutputLen); */
NS_IMETHODIMP nsPipeTransport::ReadLine(PRInt32 maxOutputLen, char **_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long bufferSegmentSize; */
NS_IMETHODIMP nsPipeTransport::GetBufferSegmentSize(PRUint32 *aBufferSegmentSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetBufferSegmentSize(PRUint32 aBufferSegmentSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long bufferMaxSize; */
NS_IMETHODIMP nsPipeTransport::GetBufferMaxSize(PRUint32 *aBufferMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetBufferMaxSize(PRUint32 aBufferMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute unsigned long headersMaxSize; */
NS_IMETHODIMP nsPipeTransport::GetHeadersMaxSize(PRUint32 *aHeadersMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransport::SetHeadersMaxSize(PRUint32 aHeadersMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportHeaders */
#define NS_IPIPETRANSPORTHEADERS_IID_STR "8431e110-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTHEADERS_IID \
  {0x8431e110, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransportHeaders : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTHEADERS_IID)

  /**
   * Calls channel to parse MIME headers, returning content length
   * or -1 for unknown content length.
   * If invalid MIME headers or no channel set, returns error.
   */
  /* long parseMimeHeaders (in string mimeHeaders, in unsigned long count); */
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportHeaders, NS_IPIPETRANSPORTHEADERS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTHEADERS \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTHEADERS(_to) \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) { return _to ParseMimeHeaders(mimeHeaders, count, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTHEADERS(_to) \
  NS_SCRIPTABLE NS_IMETHOD ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->ParseMimeHeaders(mimeHeaders, count, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportHeaders : public nsIPipeTransportHeaders
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTHEADERS

  nsPipeTransportHeaders();

private:
  ~nsPipeTransportHeaders();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportHeaders, nsIPipeTransportHeaders)

nsPipeTransportHeaders::nsPipeTransportHeaders()
{
  /* member initializers and constructor code */
}

nsPipeTransportHeaders::~nsPipeTransportHeaders()
{
  /* destructor code */
}

/* long parseMimeHeaders (in string mimeHeaders, in unsigned long count); */
NS_IMETHODIMP nsPipeTransportHeaders::ParseMimeHeaders(const char *mimeHeaders, PRUint32 count, PRInt32 *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportListener */
#define NS_IPIPETRANSPORTLISTENER_IID_STR "8431e120-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTLISTENER_IID \
  {0x8431e120, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE NS_SCRIPTABLE nsIPipeTransportListener : public nsIPipeTransportHeaders {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTLISTENER_IID)

  /**
   * Starts listener, and invokes OnStartRequest on listener, if any.
   * NOTE: Should not be called if blocked for synchronous read.
   */
  /* void startRequest (); */
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) = 0;

  /**
   * Stops listener
   */
  /* void stopRequest (in nsresult status); */
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportListener, NS_IPIPETRANSPORTLISTENER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTLISTENER \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void); \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) { return _to StartRequest(); } \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) { return _to StopRequest(status); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTLISTENER(_to) \
  NS_SCRIPTABLE NS_IMETHOD StartRequest(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->StartRequest(); } \
  NS_SCRIPTABLE NS_IMETHOD StopRequest(nsresult status) { return !_to ? NS_ERROR_NULL_POINTER : _to->StopRequest(status); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportListener : public nsIPipeTransportListener
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTLISTENER

  nsPipeTransportListener();

private:
  ~nsPipeTransportListener();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportListener, nsIPipeTransportListener)

nsPipeTransportListener::nsPipeTransportListener()
{
  /* member initializers and constructor code */
}

nsPipeTransportListener::~nsPipeTransportListener()
{
  /* destructor code */
}

/* void startRequest (); */
NS_IMETHODIMP nsPipeTransportListener::StartRequest()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void stopRequest (in nsresult status); */
NS_IMETHODIMP nsPipeTransportListener::StopRequest(nsresult status)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportPoller */
#define NS_IPIPETRANSPORTPOLLER_IID_STR "8431e130-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTPOLLER_IID \
  {0x8431e130, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE nsIPipeTransportPoller : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTPOLLER_IID)

  /**
   * Starts polling of STDOUT
   */
  /* void asyncStart (in nsIOutputStream aOutputStream, in nsIPipeTransportListener aProxyPipeObserver, in boolean joinable, in unsigned long aMimeHeadersMaxSize); */
  NS_IMETHOD AsyncStart(nsIOutputStream *aOutputStream, nsIPipeTransportListener *aProxyPipeObserver, PRBool joinable, PRUint32 aMimeHeadersMaxSize) = 0;

  /**
   * Interrupts polling thread.
   */
  /* boolean interrupt (); */
  NS_IMETHOD Interrupt(PRBool *_retval NS_OUTPARAM) = 0;

  /**
   * Returns true if polling thread has been interrupted/
   */
  /* boolean isInterrupted (); */
  NS_IMETHOD IsInterrupted(PRBool *_retval NS_OUTPARAM) = 0;

  /**
   * Joins polling thread, if joinable (blocking until it terminates)
   */
  /* void join (); */
  NS_IMETHOD Join(void) = 0;

  /**
   * Controls console logging of STDOUT from process
   */
  /* attribute boolean loggingEnabled; */
  NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) = 0;
  NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportPoller, NS_IPIPETRANSPORTPOLLER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTPOLLER \
  NS_IMETHOD AsyncStart(nsIOutputStream *aOutputStream, nsIPipeTransportListener *aProxyPipeObserver, PRBool joinable, PRUint32 aMimeHeadersMaxSize); \
  NS_IMETHOD Interrupt(PRBool *_retval NS_OUTPARAM); \
  NS_IMETHOD IsInterrupted(PRBool *_retval NS_OUTPARAM); \
  NS_IMETHOD Join(void); \
  NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled); \
  NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTPOLLER(_to) \
  NS_IMETHOD AsyncStart(nsIOutputStream *aOutputStream, nsIPipeTransportListener *aProxyPipeObserver, PRBool joinable, PRUint32 aMimeHeadersMaxSize) { return _to AsyncStart(aOutputStream, aProxyPipeObserver, joinable, aMimeHeadersMaxSize); } \
  NS_IMETHOD Interrupt(PRBool *_retval NS_OUTPARAM) { return _to Interrupt(_retval); } \
  NS_IMETHOD IsInterrupted(PRBool *_retval NS_OUTPARAM) { return _to IsInterrupted(_retval); } \
  NS_IMETHOD Join(void) { return _to Join(); } \
  NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return _to GetLoggingEnabled(aLoggingEnabled); } \
  NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return _to SetLoggingEnabled(aLoggingEnabled); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTPOLLER(_to) \
  NS_IMETHOD AsyncStart(nsIOutputStream *aOutputStream, nsIPipeTransportListener *aProxyPipeObserver, PRBool joinable, PRUint32 aMimeHeadersMaxSize) { return !_to ? NS_ERROR_NULL_POINTER : _to->AsyncStart(aOutputStream, aProxyPipeObserver, joinable, aMimeHeadersMaxSize); } \
  NS_IMETHOD Interrupt(PRBool *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->Interrupt(_retval); } \
  NS_IMETHOD IsInterrupted(PRBool *_retval NS_OUTPARAM) { return !_to ? NS_ERROR_NULL_POINTER : _to->IsInterrupted(_retval); } \
  NS_IMETHOD Join(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Join(); } \
  NS_IMETHOD GetLoggingEnabled(PRBool *aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->GetLoggingEnabled(aLoggingEnabled); } \
  NS_IMETHOD SetLoggingEnabled(PRBool aLoggingEnabled) { return !_to ? NS_ERROR_NULL_POINTER : _to->SetLoggingEnabled(aLoggingEnabled); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportPoller : public nsIPipeTransportPoller
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTPOLLER

  nsPipeTransportPoller();

private:
  ~nsPipeTransportPoller();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportPoller, nsIPipeTransportPoller)

nsPipeTransportPoller::nsPipeTransportPoller()
{
  /* member initializers and constructor code */
}

nsPipeTransportPoller::~nsPipeTransportPoller()
{
  /* destructor code */
}

/* void asyncStart (in nsIOutputStream aOutputStream, in nsIPipeTransportListener aProxyPipeObserver, in boolean joinable, in unsigned long aMimeHeadersMaxSize); */
NS_IMETHODIMP nsPipeTransportPoller::AsyncStart(nsIOutputStream *aOutputStream, nsIPipeTransportListener *aProxyPipeObserver, PRBool joinable, PRUint32 aMimeHeadersMaxSize)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean interrupt (); */
NS_IMETHODIMP nsPipeTransportPoller::Interrupt(PRBool *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isInterrupted (); */
NS_IMETHODIMP nsPipeTransportPoller::IsInterrupted(PRBool *_retval NS_OUTPARAM)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void join (); */
NS_IMETHODIMP nsPipeTransportPoller::Join()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* attribute boolean loggingEnabled; */
NS_IMETHODIMP nsPipeTransportPoller::GetLoggingEnabled(PRBool *aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}
NS_IMETHODIMP nsPipeTransportPoller::SetLoggingEnabled(PRBool aLoggingEnabled)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIPipeTransportWriter */
#define NS_IPIPETRANSPORTWRITER_IID_STR "8431e190-7ab1-11d4-8f02-006008948af5"

#define NS_IPIPETRANSPORTWRITER_IID \
  {0x8431e190, 0x7ab1, 0x11d4, \
    { 0x8f, 0x02, 0x00, 0x60, 0x08, 0x94, 0x8a, 0xf5 }}

class NS_NO_VTABLE nsIPipeTransportWriter : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IPIPETRANSPORTWRITER_IID)

  /**
   * writes count bytes from input stream to STDIN pipe (asynchronously) and
   * then closes the STDIN pipe
   */
  /* void writeFromStream (in nsIInputStream aFromStream, in unsigned long aCount, in IPCFileDescStar pipe, in boolean closeAfterWrite); */
  NS_IMETHOD WriteFromStream(nsIInputStream *aFromStream, PRUint32 aCount, IPCFileDesc * pipe, PRBool closeAfterWrite) = 0;

  /**
   * Joins writer thread, if joinable (blocking until it terminates)
   */
  /* void join (); */
  NS_IMETHOD Join(void) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIPipeTransportWriter, NS_IPIPETRANSPORTWRITER_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIPIPETRANSPORTWRITER \
  NS_IMETHOD WriteFromStream(nsIInputStream *aFromStream, PRUint32 aCount, IPCFileDesc * pipe, PRBool closeAfterWrite); \
  NS_IMETHOD Join(void); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIPIPETRANSPORTWRITER(_to) \
  NS_IMETHOD WriteFromStream(nsIInputStream *aFromStream, PRUint32 aCount, IPCFileDesc * pipe, PRBool closeAfterWrite) { return _to WriteFromStream(aFromStream, aCount, pipe, closeAfterWrite); } \
  NS_IMETHOD Join(void) { return _to Join(); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIPIPETRANSPORTWRITER(_to) \
  NS_IMETHOD WriteFromStream(nsIInputStream *aFromStream, PRUint32 aCount, IPCFileDesc * pipe, PRBool closeAfterWrite) { return !_to ? NS_ERROR_NULL_POINTER : _to->WriteFromStream(aFromStream, aCount, pipe, closeAfterWrite); } \
  NS_IMETHOD Join(void) { return !_to ? NS_ERROR_NULL_POINTER : _to->Join(); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsPipeTransportWriter : public nsIPipeTransportWriter
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIPIPETRANSPORTWRITER

  nsPipeTransportWriter();

private:
  ~nsPipeTransportWriter();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS1(nsPipeTransportWriter, nsIPipeTransportWriter)

nsPipeTransportWriter::nsPipeTransportWriter()
{
  /* member initializers and constructor code */
}

nsPipeTransportWriter::~nsPipeTransportWriter()
{
  /* destructor code */
}

/* void writeFromStream (in nsIInputStream aFromStream, in unsigned long aCount, in IPCFileDescStar pipe, in boolean closeAfterWrite); */
NS_IMETHODIMP nsPipeTransportWriter::WriteFromStream(nsIInputStream *aFromStream, PRUint32 aCount, IPCFileDesc * pipe, PRBool closeAfterWrite)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void join (); */
NS_IMETHODIMP nsPipeTransportWriter::Join()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsIPipeTransport_h__ */
